'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _coldboxElixir = require('coldbox-elixir');

var _coldboxElixir2 = _interopRequireDefault(_coldboxElixir);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _gulpFilter = require('gulp-filter');

var _gulpFilter2 = _interopRequireDefault(_gulpFilter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var gulpTypescript = void 0,
    concat = void 0,
    fs = void 0;

var TypescriptTask = function (_Elixir$Task) {
    _inherits(TypescriptTask, _Elixir$Task);

    function TypescriptTask(name, paths, options) {
        _classCallCheck(this, TypescriptTask);

        var _this = _possibleConstructorReturn(this, (TypescriptTask.__proto__ || Object.getPrototypeOf(TypescriptTask)).call(this, name, null, paths));

        _this.options = options;
        return _this;
    }

    /**
     * Lazy load the task dependencies.
     */


    _createClass(TypescriptTask, [{
        key: 'loadDependencies',
        value: function loadDependencies() {
            gulpTypescript = require('gulp-typescript');
            concat = require('gulp-concat');
            fs = require('fs');
        }

        /**
         * Build the Gulp task.
         */

    }, {
        key: 'gulpTask',
        value: function gulpTask() {
            var jsFiles = (0, _gulpFilter2.default)(['**/*.js'], { restore: true });
            return gulp.src(this.paths.src.path).pipe(this.initSourceMaps()).pipe(this.typescript()).on('error', this.onError())
            //.pipe($.concat(paths.output.name))
            .pipe(jsFiles).pipe(this.minify()).on('error', this.onError()).pipe(this.writeSourceMaps()).pipe(this.saveAs(gulp)).pipe(this.onSuccess());
        }
    }, {
        key: 'typescript',
        value: function typescript() {
            this.recordStep('Transpiling Typescript files');

            if (fs.existsSync('tsconfig.json')) {

                this.recordStep('Using tsconfig.json');
                return gulpTypescript.createProject('tsconfig.json', this.options)(gulpTypescript.reporter.defaultReporter());
            }

            return gulpTypescript(this.options, gulpTypescript.reporter.defaultReporter());
        }

        /**
        * Register file watchers.
        */

    }, {
        key: 'registerWatchers',
        value: function registerWatchers() {
            this.watch(_path2.default.join(this.paths.src.baseDir, "**/*.ts")).ignore(this.paths.output.path);
        }
    }]);

    return TypescriptTask;
}(_coldboxElixir2.default.Task);

exports.default = TypescriptTask;