'use strict';

var _coldboxElixir = require('coldbox-elixir');

var _coldboxElixir2 = _interopRequireDefault(_coldboxElixir);

var _TypescriptTask = require('./TypescriptTask');

var _TypescriptTask2 = _interopRequireDefault(_TypescriptTask);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_coldboxElixir2.default.config.typescript = {
    folder: _path2.default.join(_coldboxElixir2.default.config.assetsPath, "typescript")
};

/*
 |----------------------------------------------------------------
 | Typescript
 |----------------------------------------------------------------
 |
 | TypeScript is a typed superset of JavaScript that
 | compiles to plain JavaScript. Any browser. Any host.
 | Any OS. Open source.
 |
 */

_coldboxElixir2.default.extend('typescript', function (scripts, output, baseDir, options) {
    new _TypescriptTask2.default('typescript', getPaths(scripts, baseDir, output), options);
});

/**
 * Prep the Gulp src and output paths.
 *
 * @param  {string|Array} src
 * @param  {string|null}  output
 * @return {GulpPaths}
 */
var getPaths = function getPaths(src, baseDir, output) {
    return new _coldboxElixir2.default.GulpPaths().src(src, baseDir || _coldboxElixir2.default.config.typescript.folder).output(output || _coldboxElixir2.default.config.get('public.js.outputFolder'), 'all.js');
};